diff --git a/src/backend/optimizer/util/relnode.c b/src/backend/optimizer/util/relnode.c
new file mode 100644
index 7a8674d..126120f
*** a/src/backend/optimizer/util/relnode.c
--- b/src/backend/optimizer/util/relnode.c
*************** typedef struct JoinHashEntry
*** 33,39 ****
  } JoinHashEntry;
  
  static void build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 					RelOptInfo *input_rel);
  static List *build_joinrel_restrictlist(PlannerInfo *root,
  						   RelOptInfo *joinrel,
  						   RelOptInfo *outer_rel,
--- 33,39 ----
  } JoinHashEntry;
  
  static void build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 								RelOptInfo *input_rel, bool grouped);
  static List *build_joinrel_restrictlist(PlannerInfo *root,
  						   RelOptInfo *joinrel,
  						   RelOptInfo *outer_rel,
*************** build_simple_rel(PlannerInfo *root, int
*** 106,114 ****
--- 106,117 ----
  	rel->consider_param_startup = false;		/* might get changed later */
  	rel->consider_parallel = false;		/* might get changed later */
  	rel->reltarget = create_empty_pathtarget();
+ 	/* Not all relations have this target. */
+ 	rel->reltarget_grouped = NULL;
  	rel->pathlist = NIL;
  	rel->ppilist = NIL;
  	rel->partial_pathlist = NIL;
+ 	rel->partial_grouped_pathlist = NIL;
  	rel->cheapest_startup_path = NULL;
  	rel->cheapest_total_path = NULL;
  	rel->cheapest_unique_path = NULL;
*************** build_join_rel(PlannerInfo *root,
*** 371,379 ****
--- 374,385 ----
  	joinrel->consider_param_startup = false;
  	joinrel->consider_parallel = false;
  	joinrel->reltarget = create_empty_pathtarget();
+ 	/* Not all joins have this target. */
+ 	joinrel->reltarget_grouped = NULL;
  	joinrel->pathlist = NIL;
  	joinrel->ppilist = NIL;
  	joinrel->partial_pathlist = NIL;
+ 	joinrel->partial_grouped_pathlist = NIL;
  	joinrel->cheapest_startup_path = NULL;
  	joinrel->cheapest_total_path = NULL;
  	joinrel->cheapest_unique_path = NULL;
*************** build_join_rel(PlannerInfo *root,
*** 459,468 ****
  	 * and inner rels we first try to build it from.  But the contents should
  	 * be the same regardless.
  	 */
! 	build_joinrel_tlist(root, joinrel, outer_rel);
! 	build_joinrel_tlist(root, joinrel, inner_rel);
  	add_placeholders_to_joinrel(root, joinrel, outer_rel, inner_rel);
  
  	/*
  	 * add_placeholders_to_joinrel also took care of adding the ph_lateral
  	 * sets of any PlaceHolderVars computed here to direct_lateral_relids, so
--- 465,488 ----
  	 * and inner rels we first try to build it from.  But the contents should
  	 * be the same regardless.
  	 */
! 	build_joinrel_tlist(root, joinrel, outer_rel, false);
! 	build_joinrel_tlist(root, joinrel, inner_rel, false);
  	add_placeholders_to_joinrel(root, joinrel, outer_rel, inner_rel);
  
+ 	/* Build reltarget_grouped if appropriate. */
+ 	if (outer_rel->reltarget_grouped && inner_rel->reltarget_grouped &&
+ 		root->all_baserels_grouped)
+ 	{
+ 		build_joinrel_tlist(root, joinrel, outer_rel, true);
+ 		build_joinrel_tlist(root, joinrel, inner_rel, true);
+ 
+ 		/*
+ 		 * No need to add PHVs - if there were some, it'd mean that the join
+ 		 * is below nullable side of outer join, in which case no
+ 		 * pre-aggregation should take place.
+ 		 */
+ 	}
+ 
  	/*
  	 * add_placeholders_to_joinrel also took care of adding the ph_lateral
  	 * sets of any PlaceHolderVars computed here to direct_lateral_relids, so
*************** min_join_parameterization(PlannerInfo *r
*** 607,622 ****
   */
  static void
  build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 					RelOptInfo *input_rel)
  {
  	Relids		relids = joinrel->relids;
  	ListCell   *vars;
  
! 	foreach(vars, input_rel->reltarget->exprs)
  	{
  		Var		   *var = (Var *) lfirst(vars);
  		RelOptInfo *baserel;
  		int			ndx;
  
  		/*
  		 * Ignore PlaceHolderVars in the input tlists; we'll make our own
--- 627,665 ----
   */
  static void
  build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 					RelOptInfo *input_rel, bool grouped)
  {
  	Relids		relids = joinrel->relids;
+ 	PathTarget *reltarget_input, *reltarget_result;
  	ListCell   *vars;
+ 	int			i = -1;
  
! 	if (!grouped)
! 	{
! 		reltarget_input = input_rel->reltarget;
! 		reltarget_result = joinrel->reltarget;
! 	}
! 	else
! 	{
! 		reltarget_input = input_rel->reltarget_grouped;
! 		/* Shouldn't be called otherwise. */
! 		Assert(reltarget_input != NULL);
! 
! 		/* Called first time for this joinrel? */
! 		if (joinrel->reltarget_grouped == NULL)
! 			joinrel->reltarget_grouped = create_empty_pathtarget();
! 
! 		reltarget_result = joinrel->reltarget_grouped;
! 	}
! 
! 	foreach(vars, reltarget_input->exprs)
  	{
  		Var		   *var = (Var *) lfirst(vars);
  		RelOptInfo *baserel;
  		int			ndx;
+ 		Index		sortgroupref = 0;
+ 
+ 		i++;
  
  		/*
  		 * Ignore PlaceHolderVars in the input tlists; we'll make our own
*************** build_joinrel_tlist(PlannerInfo *root, R
*** 642,650 ****
  		if (bms_nonempty_difference(baserel->attr_needed[ndx], relids))
  		{
  			/* Yup, add it to the output */
! 			joinrel->reltarget->exprs = lappend(joinrel->reltarget->exprs, var);
  			/* Vars have cost zero, so no need to adjust reltarget->cost */
! 			joinrel->reltarget->width += baserel->attr_widths[ndx];
  		}
  	}
  }
--- 685,697 ----
  		if (bms_nonempty_difference(baserel->attr_needed[ndx], relids))
  		{
  			/* Yup, add it to the output */
! 			if (reltarget_input->sortgrouprefs)
! 				sortgroupref = reltarget_input->sortgrouprefs[i];
! 			add_column_to_pathtarget(reltarget_result, (Expr *) var,
! 									 sortgroupref);
! 
  			/* Vars have cost zero, so no need to adjust reltarget->cost */
! 			reltarget_result->width += baserel->attr_widths[ndx];
  		}
  	}
  }
diff --git a/src/backend/optimizer/util/tlist.c b/src/backend/optimizer/util/tlist.c
new file mode 100644
index 45205a8..423a39e
*** a/src/backend/optimizer/util/tlist.c
--- b/src/backend/optimizer/util/tlist.c
*************** apply_pathtarget_labeling_to_tlist(List
*** 759,761 ****
--- 759,896 ----
  		i++;
  	}
  }
+ 
+ /*
+  * Replace each "grouped var" in the source target with its "intermediate
+  * expression" if one exists, i.e. apply the effect of joins to the result of
+  * partial aggregation emitted by base relation.
+  */
+ PathTarget *
+ create_intermediate_grouping_target(PlannerInfo *root, PathTarget *src)
+ {
+ 	PathTarget	*result = create_empty_pathtarget();
+ 	int		i = 0;
+ 	ListCell	*l;
+ 
+ 	foreach(l, src->exprs)
+ 	{
+ 		Expr	*expr, *expr_new;
+ 		Index	sortgroupref = 0;
+ 
+ 		if (src->sortgrouprefs)
+ 			sortgroupref = src->sortgrouprefs[i];
+ 
+ 		expr_new = expr = (Expr *) lfirst(l);
+ 		if (IsA(expr, Var))
+ 		{
+ 			Var	*var = (Var *) expr;
+ 			ListCell	*lc;
+ 
+ 			foreach(lc, root->grouped_var_list)
+ 			{
+ 				GroupedVarInfo *gvi = (GroupedVarInfo *) lfirst(lc);
+ 
+ 				if (gvi->expr_intermediate &&
+ 					gvi->var->varno == var->varno &&
+ 					gvi->var->varattno == var->varattno)
+ 				{
+ 					/* XXX Need a copy? */
+ 					expr_new = gvi->expr_intermediate;
+ 					break;
+ 				}
+ 			}
+ 		}
+ 		add_column_to_pathtarget(result, expr_new, sortgroupref);
+ 
+ 		i++;
+ 	}
+ 
+ 	return result;
+ }
+ 
+ /*
+  * Replace each "grouped var" in the source targetlist with the original
+  * expression. This includes the items already replaced by "intermediate
+  * expression", see create_intermediate_grouping_target.
+  *
+  * TODO Think of more suitable name. Although "grouped var" may substitute for
+  * grouping expressions in the future, currently Aggref is the only outcome of
+  * the replacement. undo_grouped_var_substitutions?
+  */
+ List *
+ restore_grouping_expressions(PlannerInfo *root, List *src)
+ {
+ 	List	*result = NIL;
+ 	ListCell	*l;
+ 
+ 	foreach(l, src)
+ 	{
+ 		TargetEntry	*te, *te_new;
+ 		Expr	*expr_new = NULL;
+ 
+ 		te = (TargetEntry *) lfirst(l);
+ 
+ 		if (IsA(te->expr, Var))
+ 		{
+ 			Var	*var = (Var *) te->expr;
+ 
+ 			expr_new = find_grouped_var_expr(root, var);
+ 		}
+ 		else
+ 		{
+ 			/* Is this the "intermediate expression"? */
+ 			ListCell	*lc;
+ 
+ 			foreach(lc, root->grouped_var_list)
+ 			{
+ 				GroupedVarInfo *gvi = (GroupedVarInfo *) lfirst(lc);
+ 
+ 				/*
+ 				 * If expr_intermediate was valid, the var should already have
+ 				 * been replaced by the "intermediate expression" (which
+ 				 * should be non-Var).
+ 				 */
+ 				if (gvi->expr_intermediate != NULL &&
+ 					equal(te->expr, gvi->expr_intermediate))
+ 				{
+ 					/* XXX Need a copy? */
+ 					expr_new = gvi->expr;
+ 					break;
+ 				}
+ 			}
+ 		}
+ 		if (expr_new != NULL)
+ 		{
+ 			te_new = flatCopyTargetEntry(te);
+ 			te_new->expr = expr_new;
+ 		}
+ 		else
+ 			te_new = te;
+ 		result = lappend(result, te_new);
+ 	}
+ 
+ 	return result;
+ }
+ 
+ /*
+  * Find the expression that we've replaced with grouped var earlier.
+  */
+ Expr *
+ find_grouped_var_expr(PlannerInfo *root, Var *var)
+ {
+ 	ListCell	*lc;
+ 
+ 	foreach(lc, root->grouped_var_list)
+ 	{
+ 		GroupedVarInfo *gvi = (GroupedVarInfo *) lfirst(lc);
+ 
+ 		if (gvi->var->varno == var->varno &&
+ 			gvi->var->varattno == var->varattno)
+ 		{
+ 			/* XXX Need a copy? */
+ 			return gvi->expr;
+ 		}
+ 	}
+ 
+ 	return NULL;
+ }
diff --git a/src/backend/parser/parse_func.c b/src/backend/parser/parse_func.c
new file mode 100644
index 1297960..ed521bb
*** a/src/backend/parser/parse_func.c
--- b/src/backend/parser/parse_func.c
*************** ParseFuncOrColumn(ParseState *pstate, Li
*** 95,100 ****
--- 95,101 ----
  	FuncDetailCode fdresult;
  	char		aggkind = 0;
  	ParseCallbackState pcbstate;
+ 	Oid			aggtransmultifn = InvalidOid;
  
  	/*
  	 * If there's an aggregate filter, transform it using transformWhereClause
*************** ParseFuncOrColumn(ParseState *pstate, Li
*** 318,323 ****
--- 319,325 ----
  		classForm = (Form_pg_aggregate) GETSTRUCT(tup);
  		aggkind = classForm->aggkind;
  		catDirectArgs = classForm->aggnumdirectargs;
+ 		aggtransmultifn = classForm->aggtransmultifn;
  		ReleaseSysCache(tup);
  
  		/* Now check various disallowed cases. */
*************** ParseFuncOrColumn(ParseState *pstate, Li
*** 662,667 ****
--- 664,670 ----
  		aggref->aggstar = agg_star;
  		aggref->aggvariadic = func_variadic;
  		aggref->aggkind = aggkind;
+ 		aggref->aggtransmultifn = aggtransmultifn;
  		/* agglevelsup will be set by transformAggregateCall */
  		aggref->aggsplit = AGGSPLIT_SIMPLE;		/* planner might change this */
  		aggref->location = location;
diff --git a/src/backend/utils/adt/float.c b/src/backend/utils/adt/float.c
new file mode 100644
index 86b46de..be7ef22
*** a/src/backend/utils/adt/float.c
--- b/src/backend/utils/adt/float.c
*************** float4_accum(PG_FUNCTION_ARGS)
*** 2630,2635 ****
--- 2630,2663 ----
  	}
  }
  
+ /*
+  * State multiplication function for sum(float4) aggregate.
+  */
+ Datum
+ float4_sum_mul(PG_FUNCTION_ARGS)
+ {
+ 	float4	state = PG_GETARG_FLOAT4(0);
+ 	int64	factor;
+ 
+ #ifndef USE_FLOAT8_BYVAL	/* controls int8 too */
+ 	{
+ 		int64	*factor_p = (int64 *) PG_GETARG_POINTER(1);
+ 
+ 		factor = *factor_p;
+ 	}
+ #else
+ 	factor = PG_GETARG_INT64(1);
+ #endif
+ 
+ 	/*
+ 	 * Sum of a single group is added each time the same input set is
+ 	 * aggregated again.
+ 	 */
+ 	state *= (float8) factor;
+ 
+ 	PG_RETURN_FLOAT4(state);
+ }
+ 
  Datum
  float8_avg(PG_FUNCTION_ARGS)
  {
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
new file mode 100644
index 301dffa..063adbb
*** a/src/backend/utils/adt/selfuncs.c
--- b/src/backend/utils/adt/selfuncs.c
***************
*** 111,116 ****
--- 111,117 ----
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_type.h"
  #include "executor/executor.h"
+ #include "executor/nodeAgg.h"
  #include "mb/pg_wchar.h"
  #include "nodes/makefuncs.h"
  #include "nodes/nodeFuncs.h"
*************** estimate_hash_bucketsize(PlannerInfo *ro
*** 3657,3662 ****
--- 3658,3691 ----
  	return (Selectivity) estfract;
  }
  
+ /*
+  * estimate_hashagg_tablesize
+  *	  estimate the number of bytes that a hash aggregate hashtable will
+  *	  require based on the agg_costs, path width and dNumGroups.
+  */
+ Size
+ estimate_hashagg_tablesize(Path *path, const AggClauseCosts *agg_costs,
+ 						   double dNumGroups)
+ {
+ 	Size		hashentrysize;
+ 
+ 	/* Estimate per-hash-entry space at tuple width... */
+ 	hashentrysize = MAXALIGN(path->pathtarget->width) +
+ 		MAXALIGN(SizeofMinimalTupleHeader);
+ 
+ 	/* plus space for pass-by-ref transition values... */
+ 	hashentrysize += agg_costs->transitionSpace;
+ 	/* plus the per-hash-entry overhead */
+ 	hashentrysize += hash_agg_entry_size(agg_costs->numAggs);
+ 
+ 	/*
+ 	 * Note that this disregards the effect of fill-factor and growth policy
+ 	 * of the hash-table. That's probably ok, given default the default
+ 	 * fill-factor is relatively high. It'd be hard to meaningfully factor in
+ 	 * "double-in-size" growth policies here.
+ 	 */
+ 	return hashentrysize * dNumGroups;
+ }
  
  /*-------------------------------------------------------------------------
   *
diff --git a/src/include/catalog/pg_aggregate.h b/src/include/catalog/pg_aggregate.h
new file mode 100644
index 1ffde6c..f0b5498
*** a/src/include/catalog/pg_aggregate.h
--- b/src/include/catalog/pg_aggregate.h
***************
*** 32,37 ****
--- 32,38 ----
   *	aggkind				aggregate kind, see AGGKIND_ categories below
   *	aggnumdirectargs	number of arguments that are "direct" arguments
   *	aggtransfn			transition function
+  *	aggtransmultifn		transition state multiplication function
   *	aggfinalfn			final function (0 if none)
   *	aggcombinefn		combine function (0 if none)
   *	aggserialfn			function to convert transtype to bytea (0 if none)
*************** CATALOG(pg_aggregate,2600) BKI_WITHOUT_O
*** 58,63 ****
--- 59,65 ----
  	char		aggkind;
  	int16		aggnumdirectargs;
  	regproc		aggtransfn;
+ 	regproc		aggtransmultifn;
  	regproc		aggfinalfn;
  	regproc		aggcombinefn;
  	regproc		aggserialfn;
*************** typedef FormData_pg_aggregate *Form_pg_a
*** 91,117 ****
   * ----------------
   */
  
! #define Natts_pg_aggregate					20
  #define Anum_pg_aggregate_aggfnoid			1
  #define Anum_pg_aggregate_aggkind			2
  #define Anum_pg_aggregate_aggnumdirectargs	3
  #define Anum_pg_aggregate_aggtransfn		4
! #define Anum_pg_aggregate_aggfinalfn		5
! #define Anum_pg_aggregate_aggcombinefn		6
! #define Anum_pg_aggregate_aggserialfn		7
! #define Anum_pg_aggregate_aggdeserialfn		8
! #define Anum_pg_aggregate_aggmtransfn		9
! #define Anum_pg_aggregate_aggminvtransfn	10
! #define Anum_pg_aggregate_aggmfinalfn		11
! #define Anum_pg_aggregate_aggfinalextra		12
! #define Anum_pg_aggregate_aggmfinalextra	13
! #define Anum_pg_aggregate_aggsortop			14
! #define Anum_pg_aggregate_aggtranstype		15
! #define Anum_pg_aggregate_aggtransspace		16
! #define Anum_pg_aggregate_aggmtranstype		17
! #define Anum_pg_aggregate_aggmtransspace	18
! #define Anum_pg_aggregate_agginitval		19
! #define Anum_pg_aggregate_aggminitval		20
  
  /*
   * Symbolic values for aggkind column.  We distinguish normal aggregates
--- 93,120 ----
   * ----------------
   */
  
! #define Natts_pg_aggregate					21
  #define Anum_pg_aggregate_aggfnoid			1
  #define Anum_pg_aggregate_aggkind			2
  #define Anum_pg_aggregate_aggnumdirectargs	3
  #define Anum_pg_aggregate_aggtransfn		4
! #define Anum_pg_aggregate_aggtransmultifn	5
! #define Anum_pg_aggregate_aggfinalfn		6
! #define Anum_pg_aggregate_aggcombinefn		7
! #define Anum_pg_aggregate_aggserialfn		8
! #define Anum_pg_aggregate_aggdeserialfn		9
! #define Anum_pg_aggregate_aggmtransfn		10
! #define Anum_pg_aggregate_aggminvtransfn	11
! #define Anum_pg_aggregate_aggmfinalfn		12
! #define Anum_pg_aggregate_aggfinalextra		13
! #define Anum_pg_aggregate_aggmfinalextra	14
! #define Anum_pg_aggregate_aggsortop			15
! #define Anum_pg_aggregate_aggtranstype		16
! #define Anum_pg_aggregate_aggtransspace		17
! #define Anum_pg_aggregate_aggmtranstype		18
! #define Anum_pg_aggregate_aggmtransspace	19
! #define Anum_pg_aggregate_agginitval		20
! #define Anum_pg_aggregate_aggminitval		21
  
  /*
   * Symbolic values for aggkind column.  We distinguish normal aggregates
